Package ghidra.trace.database.target.visitors

# Enum Class AllPathsVisitor

java.lang.Object
java.lang.Enum<AllPathsVisitor>
ghidra.trace.database.target.visitors.AllPathsVisitor

All Implemented Interfaces:
  `TreeTraversal.SpanIntersectingVisitor`, `TreeTraversal.Visitor`, `Serializable`, `Comparable<AllPathsVisitor>`, `Constable`

public enum AllPathsVisitor extends Enum<AllPathsVisitor> implements TreeTraversal.SpanIntersectingVisitor

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `INSTANCE`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `TraceObjectValPath`
  `composePath(TraceObjectValPath pre, TraceObjectValue value)`
  When descending in a value, what path leads to the value
  `TraceObject`
  `continueObject(TraceObjectValue value)`
  When descending in a value, the object to consider next
  `Stream<? extends TraceObjectValue>`
  `continueValues(TraceObject object, Lifespan span, TraceObjectValPath path)`
  When descending in an object, the values to consider next
  `static AllPathsVisitor`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static AllPathsVisitor[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.
  `TreeTraversal.VisitResult`
  `visitValue(TraceObjectValue value, TraceObjectValPath path)`
  Visit a value

  ### Methods inherited from class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface ghidra.trace.database.target.visitors.TreeTraversal.SpanIntersectingVisitor

  `composeSpan`

- ## Enum Constant Details

  - ### INSTANCE

    public static final AllPathsVisitor INSTANCE

- ## Method Details

  - ### values

    public static AllPathsVisitor[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static AllPathsVisitor valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### composePath

    public TraceObjectValPath composePath(TraceObjectValPath pre, TraceObjectValue value)
    Description copied from interface: `TreeTraversal.Visitor`
    When descending in a value, what path leads to the value

    This is usually `TraceObjectValPath.append(TraceObjectValue)` or `TraceObjectValPath.prepend(TraceObjectValue)`.

    Specified by:
      `composePath` in interface `TreeTraversal.Visitor`
    Parameters:
      `pre` - the path from seed to the but excluding the current value
      `value` - the path from seed to the and including the current value
    Returns:
      the path from seed to and including the current value

  - ### visitValue

    public TreeTraversal.VisitResult visitValue(TraceObjectValue value, TraceObjectValPath path)
    Description copied from interface: `TreeTraversal.Visitor`
    Visit a value

    Note that the path is the composed path, so it will likely have the current value at its beginning or end.

    Specified by:
      `visitValue` in interface `TreeTraversal.Visitor`
    Parameters:
      `value` - the current value
      `path` - the path from seed to value
    Returns:
      directions for how traversal should proceed

  - ### continueObject

    public TraceObject continueObject(TraceObjectValue value)
    Description copied from interface: `TreeTraversal.Visitor`
    When descending in a value, the object to consider next

    This is usually `TraceObjectValue.getChild()` or `TraceObjectValue.getParent()`.

    Specified by:
      `continueObject` in interface `TreeTraversal.Visitor`
    Parameters:
      `value` - the current value
    Returns:
      the next object

  - ### continueValues

    public Stream<? extends TraceObjectValue> continueValues(TraceObject object, Lifespan span, TraceObjectValPath path)
    Description copied from interface: `TreeTraversal.Visitor`
    When descending in an object, the values to consider next
    Specified by:
      `continueValues` in interface `TreeTraversal.Visitor`
    Parameters:
      `object` - the current object
      `span` - the composed span of values from seed to the current object
      `path` - the path from seed to the current object
    Returns:
      the next values